# Images. Histogram of image colors (RGB)
 

from ij import *
from ij.process import *
from jhplot import *
from jhplot.utils import ColorPixel
from java.awt import Color

imp = IJ.openImage("http://jwork.org/jhepwork/logo_jhepwork.png")
imp.show()
# Returns an RGB version of this image as a ColorProcessor.
pix=imp.getProcessor().convertToRGB().getPixels()

rgb=ColorPixel.getP0I(pix) # get pixels in the usual R,G,B 

c1 = HPlot("Image colors",600,500,1, 3)
c1.setGTitle("Histogram of image colors")
c1.visible()

red = H1D("Red",255, 0, 255)
green = H1D("green",255, 0, 255)
blue = H1D("blue", 255, 0, 255)

red.setFill(1)
red.setColor(Color.red)
red.setFillColor(Color.red)

green.setFill(1)
green.setColor(Color.green)
green.setFillColor(Color.green)

blue.setFill(1)
blue.setColor(Color.blue)
blue.setFillColor(Color.blue)

red.fill(rgb[0])     # fill histograms in one go
green.fill(rgb[1])
blue.fill(rgb[2])

# fill histograms
max=4000
c1.cd(1,1)
c1.setRange(0,255,0,max)
c1.draw(red)

c1.cd(1,2)
c1.setRange(0,255,0,max)
c1.draw(green)

c1.cd(1,3)
c1.setRange(0,255,0,max)
c1.draw(blue)
