# ROOT-I/O. Access ROOT histograms and navigate inside ROOT file 
# user cd() method of FileRoot to navigate inside ROOT file
 
from java.awt import Color
from jhplot  import *
from jhplot.io import *
 
# location of ROOT file
file=SystemDir+fSep+"macros"+fSep+"examples"+fSep+"data"+fSep+"Example.root"
rfr = FileRoot(file)
print "ROOT version=",rfr.getVersion()
print rfr.toString()

# user cd() method to navigate inside ROOT file
# here assume rot directory
h1 = rfr.getH1D("mainHistogram")
h2 = rfr.getH1D("totalHistogram")
h3 = rfr.getH1D("s1Histogram")

# create canvas 1x1
c1 = HPlot("Canvas",600,400,1, 1)
c1.setGTitle("FileRoot example")
c1.visible(1)


c1.setRange(0, -4, 4)
# set autorange for Y
c1.setAutoRange(1,1)

h1.setColor(Color(20,100,100))
c1.draw(h1)

h2.setColor(Color.red)
c1.draw(h2)

h3.setStyle("p")
h3.setDrawLine(0)
h3.setColor(Color.green)
c1.draw(h3)


c1.setNameX("Xaxis")
c1.setNameY("Yaxis")
c1.setName("Canvas title")
c1.update()



# export to some image (png,eps,pdf,jpeg...)
# c1.export(Editor.DocMasterName()+".png");
